c     +---------------------------------------------------+
c     + subroutine : co-variance matrix                   +
c     +---------------------------------------------------+
      subroutine covmat(lat,clat,sdevfg,sdevob,gscale
     +                 ,nana,latana,lonana,co)
      implicit none
      real     lat,clat,sdevfg,sdevob,gscale
      integer  nana
      real     latana(nana),lonana(nana),co(nana,nana)
      integer  k,l,km1
      real     clon,varian,diagon,dis2,cov
      real     pi

      pi = asin(1.)*2.
      clon   = clat*cos(lat*pi/180.)
      varian = sdevfg*sdevfg
      diagon = varian + sdevob*sdevob
      do k=2,nana
         km1 = k - 1
      do l=1,km1
         dis2 = (  ((latana(k)-latana(l))*clat)**2+
     +             ((lonana(k)-lonana(l))*clon)**2  )
     +          / gscale**2
         cov  = varian*exp( -dis2 )
         co(k,l) = cov
         co(l,k) = cov
      enddo
      enddo
      do k=1,nana
         co(k,k) = diagon
      enddo
      return
      end
